#!/bin/bash

filename=/etc/accton/standalone_phy.bcm
filename_soc=/etc/accton/standalone_phy.soc
# test
#filename=~kang/test/standalone_phy.bcm
#filename_soc=~kang/test/standalone_phy.soc

function add_extphy_ports()
{
  for (( i=0; i<=3; i=i+1 ))
  do
    echo "sphy_port_phy_name_"$(($1+$i))"=evora" >> ${filename}
  done
}

# MAC port (not MACsec PHY port)
# $1: port
# $2: interface type (default is SR4 for ACO module ports)
# $3: speed
#
function set_mac_interface_type_speed()
{
  echo "port" $1 "if="$2 "sp="$3 >> ${filename_soc}
}

# $1: first port
# $2: second port
#
function add_polarity_flip_qsfp28()
{
# non-breakout
#  echo "phy_xaui_rx_polarity_flip_"$1"=0x0" >> ${filename}
#  echo "phy_xaui_rx_polarity_flip_"$2"=0x5" >> ${filename}
#  echo "phy_xaui_tx_polarity_flip_"$1"=0x2" >> ${filename}
#  echo "phy_xaui_tx_polarity_flip_"$2"=0xF" >> ${filename}

# consider breakout
  for (( i=0; i<=3; i=i+1 ))
  do
    echo "phy_xaui_rx_polarity_flip_"$(($1+$i))"=0x0" >> ${filename}
  done

  echo "phy_xaui_rx_polarity_flip_"$2"=0x5" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+1))"=0x0" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+2))"=0x1" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+3))"=0x0" >> ${filename}

  echo "phy_xaui_tx_polarity_flip_"$1"=0x2" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+1))"=0x1" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+2))"=0x0" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+3))"=0x0" >> ${filename}

  echo "phy_xaui_tx_polarity_flip_"$2"=0xF" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+1))"=0x1" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+2))"=0x3" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+3))"=0x1" >> ${filename}
}

# $1: first port mdio address
# $2: second port mdio address
#
function add_polarity_swap_qsfp28_extphy()
{
  echo "extphy pn_swp set $1 if_side=1 lane=0 tx_pnswap=1 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=1 lane=1 tx_pnswap=1 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=1 lane=2 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=1 lane=3 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=0 lane=0 tx_pnswap=0 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=0 lane=1 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=0 lane=2 tx_pnswap=1 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $1 if_side=0 lane=3 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=1 lane=0 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=1 lane=1 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=1 lane=2 tx_pnswap=1 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=1 lane=3 tx_pnswap=0 rx_pnswap=1" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=0 lane=0 tx_pnswap=0 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=0 lane=1 tx_pnswap=0 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=0 lane=2 tx_pnswap=0 rx_pnswap=0" >> ${filename_soc}
  echo "extphy pn_swp set $2 if_side=0 lane=3 tx_pnswap=0 rx_pnswap=0" >> ${filename_soc}
  echo "" >> ${filename_soc}
}

# $1: first port
# $2: second port
#
function add_polarity_flip_dco()
{
  for (( i=0; i<=3; i=i+1 ))
  do
    echo "phy_xaui_rx_polarity_flip_"$(($1+$i))"=0x0" >> ${filename}
  done

  echo "phy_xaui_rx_polarity_flip_"$2"=0xC" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+1))"=0x0" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+2))"=0x3" >> ${filename}
  echo "phy_xaui_rx_polarity_flip_"$(($2+3))"=0x1" >> ${filename}

  echo "phy_xaui_tx_polarity_flip_"$1"=0x8" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+1))"=0x0" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+2))"=0x2" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($1+3))"=0x1" >> ${filename}

  echo "phy_xaui_tx_polarity_flip_"$2"=0xF" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+1))"=0x1" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+2))"=0x3" >> ${filename}
  echo "phy_xaui_tx_polarity_flip_"$(($2+3))"=0x1" >> ${filename}
}

# $1: first port
# $2: second port
# $3: rx_lane_map of 1st port
# $4: rx_lane_map of 2nd port
# $5: tx_lane_map of 1st port
# $6: tx_lane_map of 2nd port
#
function add_lane_map()
{
  for (( i=0; i<=3; i=i+1 ))
  do
    echo "xgxs_rx_lane_map_"$(($1+$i))"="$3 >> ${filename}
    echo "xgxs_rx_lane_map_"$(($2+$i))"="$4 >> ${filename}
    echo "xgxs_tx_lane_map_"$(($1+$i))"="$5 >> ${filename}
    echo "xgxs_tx_lane_map_"$(($2+$i))"="$6 >> ${filename}
  done
}

# $1: slot#
# $2: card_type: 0: Dual-QSFP28 Module
#                1: DCO Module
#
function add_extphy_cards()
{
  case ${1} in
    1|2|3|4|5|6|7|8)
      echo -n "--- MACsec PHY detected on Slot "${1}", Card type: "
      [ $2 == 0 ] && echo "Dual-QSFP28 Module"
      [ $2 == 1 ] && echo "DCO Module"
      case ${1} in
        1)
#  use c program to detect breakout to set interface type accordingly
#          set_mac_interface_type_speed 38 "CR4" 100000
#          set_mac_interface_type_speed 34 "CR4" 100000
          add_extphy_ports 38
          add_extphy_ports 34
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 38 34
            add_lane_map 38 34 0x1203 0x2130 0x3021 0x0312
            add_polarity_swap_qsfp28_extphy 0x0 0x1
            echo "extphy pre 0x0 0 0x2 0x37 0x17 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 1 0x2 0x32 0x17 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 2 0x2 0x30 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 3 0x2 0x30 0x15 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x1 0 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 1 0x2 0x37 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 2 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 3 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 38 34
            add_lane_map 38 34 0x2310 0x1023 0x2310 0x1023
            echo "extphy pre 0x0 2 0x2 0x37 0x17 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 0 0x2 0x32 0x17 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 3 0x2 0x30 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x0 1 0x2 0x30 0x15 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x1 2 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 0 0x2 0x37 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 3 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x1 1 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        2)
#          set_mac_interface_type_speed 46 "CR4" 100000
#          set_mac_interface_type_speed 42 "CR4" 100000
          add_extphy_ports 46
          add_extphy_ports 42
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 46 42
            add_lane_map 46 42 0x1203 0x2130 0x3021 0x0312
            add_polarity_swap_qsfp28_extphy 0x22 0x23
            echo "extphy pre 0x22 0 0x2 0x35 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 1 0x2 0x33 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 2 0x2 0x3e 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 3 0x2 0x42 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x23 0 0x2 0x36 0x1a 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 1 0x2 0x38 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 2 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 3 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 46 42
            add_lane_map 46 42 0x2310 0x1023 0x2310 0x1023
            echo "extphy pre 0x22 2 0x2 0x35 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 0 0x2 0x33 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 3 0x2 0x3e 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x22 1 0x2 0x42 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x23 2 0x2 0x36 0x1a 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 0 0x2 0x38 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 3 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x23 1 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        3)
#          set_mac_interface_type_speed 54 "CR4" 100000
#          set_mac_interface_type_speed 50 "CR4" 100000
          add_extphy_ports 54
          add_extphy_ports 50
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 54 50
            add_lane_map 54 50 0x2130 0x2130 0x3021 0x3021
            add_polarity_swap_qsfp28_extphy 0x4a 0x4b
            echo "extphy pre 0x4a 0 0x2 0x33 0x16 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 1 0x2 0x36 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 2 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 3 0x2 0x3a 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x4b 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 1 0x2 0x36 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 2 0x2 0x37 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 3 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 54 50
            add_lane_map 54 50 0x1023 0x1023 0x2310 0x2310
            echo "extphy pre 0x4a 2 0x2 0x33 0x16 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 0 0x2 0x36 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 3 0x2 0x35 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4a 1 0x2 0x3a 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x4b 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 0 0x2 0x36 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 3 0x2 0x37 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x4b 1 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        4)
#          set_mac_interface_type_speed 62 "CR4" 100000
#          set_mac_interface_type_speed 58 "CR4" 100000
          add_extphy_ports 62
          add_extphy_ports 58
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 62 58
            add_lane_map 62 58 0x2130 0x2130 0x3021 0x3021
            add_polarity_swap_qsfp28_extphy 0x66 0x67
            echo "extphy pre 0x66 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 1 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 2 0x2 0x37 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 3 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x67 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 1 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 2 0x2 0x38 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 3 0x2 0x3a 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 62 58
            add_lane_map 62 58 0x1023 0x1023 0x2310 0x2310
            echo "extphy pre 0x66 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 0 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 3 0x2 0x37 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x66 1 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x67 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 0 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 3 0x2 0x38 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x67 1 0x2 0x3a 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        5)
#          set_mac_interface_type_speed 5 "CR4" 100000
#          set_mac_interface_type_speed 1 "CR4" 100000
          add_extphy_ports 5
          add_extphy_ports 1
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 5 1
            add_lane_map 5 1 0x1203 0x1203 0x0312 0x0312
            add_polarity_swap_qsfp28_extphy 0x108 0x109
            echo "extphy pre 0x108 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 1 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 2 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 3 0x2 0x3a 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x109 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 1 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 2 0x2 0x3a 0x1a 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 3 0x2 0x39 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 5 1
            add_lane_map 5 1 0x2310 0x2310 0x1023 0x1023
            echo "extphy pre 0x108 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 0 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 3 0x2 0x38 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x108 1 0x2 0x3a 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x109 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 0 0x2 0x34 0x18 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 3 0x2 0x3a 0x1a 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x109 1 0x2 0x39 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        6)
#          set_mac_interface_type_speed 13 "CR4" 100000
#          set_mac_interface_type_speed 9  "CR4" 100000
          add_extphy_ports 13
          add_extphy_ports 9
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 13 9
            add_lane_map 13 9 0x1203 0x1203 0x0312 0x0312
            add_polarity_swap_qsfp28_extphy 0x12a 0x12b
            echo "extphy pre 0x12A 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 1 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 2 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 3 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x12B 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 1 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 2 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 3 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 13 9
            add_lane_map 13 9 0x2310 0x2310 0x1023 0x1023
            echo "extphy pre 0x12A 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 0 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 3 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12A 1 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x12B 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 0 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 3 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x12B 1 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        7)
#          set_mac_interface_type_speed 21 "CR4" 100000
#          set_mac_interface_type_speed 17 "CR4" 100000
          add_extphy_ports 21
          add_extphy_ports 17
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 21 17
            add_lane_map 21 17 0x1203 0x2130 0x3021 0x0312
            add_polarity_swap_qsfp28_extphy 0x14c 0x14d
            echo "extphy pre 0x14C 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 1 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 2 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 3 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x14D 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 1 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 2 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 3 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 21 17
            add_lane_map 21 17 0x2310 0x1023 0x2310 0x1023
            echo "extphy pre 0x14C 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 0 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 3 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14C 1 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x14D 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 0 0x2 0x3a 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 3 0x2 0x3a 0x1c 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x14D 1 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
        8)
#          set_mac_interface_type_speed 29 "CR4" 100000
#          set_mac_interface_type_speed 25 "CR4" 100000
          add_extphy_ports 29
          add_extphy_ports 25
          if [ $2 == 0 ]; then
            add_polarity_flip_qsfp28 29 25
            add_lane_map 29 25 0x1203 0x2130 0x3021 0x0312
            add_polarity_swap_qsfp28_extphy 0x16e 0x16f
            echo "extphy pre 0x16E 0 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 1 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 2 0x2 0x3d 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 3 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x16F 0 0x2 0x3a 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 1 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 2 0x2 0x3d 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 3 0x2 0x3e 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          else
            add_polarity_flip_dco 29 25
            add_lane_map 29 25 0x2310 0x1023 0x2310 0x1023
            echo "extphy pre 0x16E 2 0x2 0x36 0x19 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 0 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 3 0x2 0x3d 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16E 1 0x2 0x3c 0x1b 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
            echo "extphy pre 0x16F 2 0x2 0x3a 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 0 0x2 0x3a 0x1d 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 3 0x2 0x3d 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "extphy pre 0x16F 1 0x2 0x3e 0x1e 0x0 0x0 0x8" >> ${filename_soc}
            echo "" >> ${filename_soc}
          fi
          ;;
      esac
      ;;
    *)
      echo "--- invalid slot number:" ${1}
      ;;
  esac
}

#echo
#echo "--- clean port interface type setting in "${filename_soc}
#sed -i '/^port / {N;d;}' ${filename_soc}

echo "--- clean polarity swape setting in "${filename_soc}
sed -i '/^extphy pn_swp set / {N;d;}' ${filename_soc}

echo "--- clean preemphasis setting in "${filename_soc}
sed -i '/^extphy pre / {N;d;}' ${filename_soc}

# delete empty lines
sed -i '/^ *$/d' ${filename_soc}

echo "# config of the detected ports which have MACsepc PHY" > ${filename}
# test
#add_extphy_cards 1 1
#add_extphy_cards 1 1
#add_extphy_cards 2 1
#add_extphy_cards 3 1
#add_extphy_cards 4 1
#add_extphy_cards 5 1
#add_extphy_cards 6 1
#add_extphy_cards 7 1
#add_extphy_cards 8 1
#add_extphy_cards 3 0
#add_extphy_cards 4 1

# Card Type:
#   0000: dual QSFP28
#   0001: CFP2 DCO
#   0100: dual QSFP28 test module
#   0101: CFP2 DCO test module
#
# In ONL, the command for each slot is:
# i2cget -f -y XX 0x6a 0
# (XX=41, 43, 45, 47, 49, 51, 53, 55, where 41 is for slot#1, 43 is for slot#2, and so on)

slot_id=1
for slot_bus in 41 43 45 47 49 51 53 55
do
  # comment out the following line if doing test on server
  card_type=`i2cget -f -y ${slot_bus} 0x6a 0 2>/dev/null`

  if [ -n ${card_type} ]; then
    case ${card_type} in
      "0x00" | "0x0000" | "0x0100")
        echo "--- found QSFP28 module at slot" $slot_id "---"
        add_extphy_cards $slot_id 0
        ;;
      "0x01" | "0x0001" | "0x0101")
        echo "--- found CFP2 DCO  module at slot" $slot_id "---"
        add_extphy_cards $slot_id 1
        ;;
      *)
        # card not inserted or CFP2 ACO module
        ;;
    esac
  fi
  slot_id=$(($slot_id+1))
done

exit 0










